/*
 * Mesh.c
 *
 *  Created on: 2009/07/07
 *      Author: ashida
 */
#include <stdio.h>
#include <stdlib.h>
#include <Feature.h>
#include <Mesh.h>
#include <Bitmap.h>

/*  */
static void _initMesh(Mesh *mesh);

/*------------------------------------------------------------------------------------------*/
/* bVʂvZ */
void calcMeshFeature(Mesh *mesh, Bitmap *bitmap){

	/* ϐ */
	unsigned int i, j;

	/*  */
	_initMesh(mesh);

	/* rbg}bv̍JԂ */
	for(j=0; j<bitmap->height; j++){
		/* rbg}bv̕JԂ */
		for(i=0; i<bitmap->width; i++){
			/* (i,j)fȂ */
			if(getPixel(bitmap,i,j) == BLACK){
				/* ΉZɂP𑫂 */
				mesh->feature[j*MESH_HEIGHT/bitmap->height][i*MESH_WIDTH/bitmap->width]++;
			}
		}
	}
}
/*------------------------------------------------------------------------------------------*/
/* bVʂ\ */
void printMeshFeature(Mesh *mesh){
	/* ϐ */
	unsigned int i,j;
	/* ׂĂOɂ */
	for(j=0;j<MESH_HEIGHT; j++){
		for(i=0; i<MESH_WIDTH; i++){
			printf("%3d ", mesh->feature[j][i]);
		}
		printf("\n");
	}
}
/*------------------------------------------------------------------------------------------*/
/*  */
void initMeshFeature(Mesh *mesh){
	/* ϐ */
	unsigned int i,j;
	/* ׂĂOɂ */
	for(j=0;j<MESH_HEIGHT; j++){
		for(i=0; i<MESH_WIDTH; i++){
			mesh->feature[j][i] = 0;
		}
	}

}
/*------------------------------------------------------------------------------------------*/
/* bVʂĂ */
void addMeshFeature(Mesh *mesh, Mesh *sum){
	/* ϐ */
	unsigned int i,j;
	/* ׂĂOɂ */
	for(j=0;j<MESH_HEIGHT; j++){
		for(i=0; i<MESH_WIDTH; i++){
			sum->feature[j][i] += mesh->feature[j][i];
		}
	}

}
/*------------------------------------------------------------------------------------------*/
/* e */
void divideMesh(Mesh *mesh, unsigned int num){
	/* ϐ */
	unsigned int i,j;

	for(j=0; j<MESH_HEIGHT; j++){
		for(i=0; i<MESH_WIDTH; i++){
			mesh->feature[j][i] /= num;
		}
	}
}
/*------------------------------------------------------------------------------------------*/
/* 1̔zƂēʂ𓾂 */
unsigned int *getSerialFeatureMesh(Mesh *mesh){
	/* 1z */
	unsigned int *serial_feature;
	/* ϐ */
	int i,j;

	/* ̊m */
	serial_feature = (unsigned int *)malloc(sizeof(unsigned int)*MESH_WIDTH*MESH_HEIGHT);

	/* 1ɓWJ */
	for(j=0; j<MESH_HEIGHT; j++){
		for(i=0; i<MESH_WIDTH; i++){
			serial_feature[j*MESH_WIDTH+i] = mesh->feature[j][i];
		}
	}

	return serial_feature;
}
/*------------------------------------------------------------------------------------------*/
/* 1̔zƂĕ\ꂽʂbVʗpi2zjɐݒ肷 */
void setSerialFeatureMesh(Mesh *mesh, unsigned int *serial_feature){
	/* ϐ */
	int i,j;

	/* 2ɓWJ */
	for(j=0; j<MESH_HEIGHT; j++){
		for(i=0; i<MESH_WIDTH; i++){
			mesh->feature[j][i] = serial_feature[j*MESH_WIDTH+i];
		}
	}

}
/*------------------------------------------------------------------------------------------*/
/* bVʂ̎𓾂 */
unsigned int getMeshDimension(void){
	return MESH_WIDTH*MESH_HEIGHT;
}
/*------------------------------------------------------------------------------------------*/
/* 𓾂 */
unsigned int getDistanceMesh(Mesh *mesh1, Mesh *mesh2){
	/* ϐ */
	int i,j;
	/*  */
	unsigned int diff;
	/* [Nbh */
	unsigned int distance = 0;

	/* [Nbh߂ */
	for(j=0; j<MESH_HEIGHT; j++){
		for(i=0; i<MESH_WIDTH; i++){
			if( mesh1->feature[j][i] > mesh2->feature[j][i] ){
				diff = mesh1->feature[j][i] - mesh2->feature[j][i];
			}
			else{
				diff = mesh2->feature[j][i] - mesh1->feature[j][i];
			}
			distance += (diff*diff);
		}
	}
	return distance;
}
/*------------------------------------------------------------------------------------------*/
/**********************/
/* static֐ */
/**********************/
/*  */
static void _initMesh(Mesh *mesh){
	/* ϐ */
	unsigned int i,j;
	/* ׂĂOɂ */
	for(j=0;j<MESH_HEIGHT; j++){
		for(i=0; i<MESH_WIDTH; i++){
			mesh->feature[j][i] = 0;
		}
	}
}
/*------------------------------------------------------------------------------------------*/
