/*
 * Bitmap.h
 *
 *  Created on: 2009/07/07
 *      Author: ashida
 */

#ifndef BITMAP_H_
#define BITMAP_H_

// バッファサイズ
#define BUFFER_SIZE 1024

// PBMのアスキー形式で画像を表す時に，ファイルの先頭についている識別子
#define PBM_ASCII "P1"

// コメントの先頭についている識別子
#define COMMENT_PREFIX '#'

// PBMファイルで白画素を表す文字
#define WHITE_CHAR '0'
// PBMファイルで黒画素を表す文字
#define BLACK_CHAR '1'

/** 画素 */
typedef enum{
	WHITE = 0,	// 白画素
	BLACK = 1	// 黒画素
} Pixel;

/** ビットマップ構造体 */
typedef struct _Bitmap{
	// 幅
	unsigned int width;
	// 高さ
	unsigned int height;
	// ビットマップデータ
	unsigned char **data;
} Bitmap;


#endif /* BITMAP_H_ */
